   
        
;****************************************************************************************
;*                              DTMF-TON-GEBER                                          *
;*                              27.12.24                                                *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC16F1827                                                 *
;*                                                                                      *
;* ALS OSZILLATOR INTERN 32MHZ  (T=0.03125S T:=TAKTZEIT)                               *
;*                                                                                      *
;****************************************************************************************

        LIST    P=16F1827      
        TITLE   "DTMF-GEBER"

        ERRORLEVEL -302
        INCLUDE <P16F1827.INC>

;---------------------------------------------------------------------------------
 
 __CONFIG _CONFIG1, _FOSC_INTOSC & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _CP_OFF & _BOREN_ON & _IESO_OFF & 0X3FFF
 __CONFIG _CONFIG2, _WRT_OFF & _PLLEN_ON & _BORV_HI & _LVP_OFF & 0X3FFF
           
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------
 
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
           
;HIER DIE AENDERBAREN EINSTELLUNGEN
 
;MAN KANN ZAHLEN EINTRAGEN VON D'1' BIS D'255' // DIE D'0' GEHT NICHT
 
;SO WIRD DER DTMF-TON BEI EINER ABGESPEICHERTEN TONFOLGE NORMIERT AUSGEGEBEN
 
;UNTERHALB // JETZT NICHT AKTIV DA SEMIKOLON DAVOR         
;TONLAENGE               EQU D'7'               ;TONLAENGE BEIM ABSPIELEN /// JETZT 7 * 0,1SEC = 0,7SEC                                               

;TONPAUSE                EQU D'2'               ;TONPAUSENLAENGE BEIM ABSPIELEN /// JETZT 2 * 0,1SEC = 0,2SEC 

                
;UNTERHALB EINE ANDERE EINSTELLUNG ALS BEISPIEL
;UNTERHALB // JETZT AKTIV DA KEIN SEMIKOLON DAVOR               
TONLAENGE               EQU D'3'               ;TONLAENGE BEIM ABSPIELEN /// JETZT 3 * 0,1SEC = 0,3SEC

TONPAUSE                EQU D'1'               ;TONPAUSENLAENGE BEIM ABSPIELEN /// JETZT 1 * 0,1SEC = 0,1SEC

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
                
;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

W_STACK                 EQU 0X22               ;FUER PUSH UND POP
S_STACK                 EQU 0X23               ;FUER PUSH UND POP

MERK1                   EQU 0X24               ;BIT1 FUER RA1 ///BIT0 FUER RA0 --> LOW-HALBWELLE BEI LOW /// HIGH-HALBWELLE BEI HIGH
ZAE                     EQU 0X25               ;FUER ZEITSCHLEIFEN DURCHLAEUFE
EINMAL                  EQU 0X26               ;BIT0 HIGH NUR EINMAL TON_SUCH AUFRUFEN AM ANFANG
TON_RA0                 EQU 0X27               ;WERT FUER ZEITSCHLEIFE FUER TON-FREQUENZ                  
TON_RA1                 EQU 0X28               ;WERT FUER ZEITSCHLEIFE FUER TON-FREQUENZ                  
ZAE1                    EQU 0X29               ;SPRUNGADRESSE BEI DEN TON-WERTEN

AUS                     EQU 0X2A               ;BIT0 BEI HIGH IST NICHT MEHR TONTASTE GEDRCKT ALSO AUS
                     
HELP                    EQU 0X2B               ;FUER ZEITSCHLEIFEN
HELP1                   EQU 0X2C               ;FUER ZEITSCHLEIFEN                    
 
ADRR                    EQU 0X2D               ;EEPROM-ADRESSE

SYSS                    EQU 0X2E               ;BIT0 HIGH ENDE DES ABGESPEICHERTEN TONES
DAUER                   EQU 0X2F               ;DAUER DER TONLNGE 
DAUER2                  EQU 0X30               ;DAUER DER TONLNGE                                         
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ADRR_END                EQU 0X31               ;ENDE-ADRESSE FUER ABSPEICHERN
SPEICHERN               EQU 0X32               ;ABSPEICHERN BEI BIT0=HIGH                  
TAST_MERKER             EQU 0X33               ;MERKER WELCHE SPEICHER/ABSPIEL-TONFOLGE-TASTE IST GEDRUECKT
HELP2                   EQU 0X34               ;HILFSVARIABLE             
                
                
;------------------------- MACROS -----------------------------------------
;----------------------------------------------------------------------------
PPUSH                   MACRO
                        MOVWF   W_STACK
                        MOVF    STATUS, W
                        MOVWF   S_STACK
                        ENDM
;----------------------------------------------------------------------------
PPOP                    MACRO
                        MOVF    S_STACK, W
                        MOVWF   STATUS
                        SWAPF   W_STACK, F
                        SWAPF   W_STACK, W
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7

TASTE1      EQU 2       ;TASTE1 ZUM TONFOLGE STARTEN/SPEICHERN AN PORTA -->RA2

TASTE2      EQU 3       ;TASTE2 ZUM TONFOLGE STARTEN/SPEICHERN AN PORTA -->RA3

TASTE3      EQU 4       ;TASTE3 ZUM TONFOLGE STARTEN/SPEICHERN AN PORTA -->RA4

TASTE4      EQU 5       ;TASTE4 ZUM TONFOLGE STARTEN/SPEICHERN AN PORTA -->RA5

ABSPEICHERN EQU 6       ;PORTA-BIT6 -->LED LEUCHTET WAEREND DES ABSPEICHER-MODUS UND ERLISCHT BEIM BEENDEN UND UEBERSCHREITEN VON 30 DTMF-ZEICHEN      
LEUCHT      EQU 7       ;PORTA-BIT7 -->LED LEUCHTET, WENN EIN DTMF-TON BEI EINER TONFOLGE ODER EINZELBETAETIGUNG RAUS KOMMT
            
;----------------------------------------------------------------------------

      
      

;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    GOTO INTERRUPT      ; ZUM INTERRUPT

    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
MAIN
;PORT-INITIALISIERUNG USW...
                        MOVLB   D'0'        ;BANK0
                        CLRF    PORTA     
                        CLRF    PORTB
                        
                        MOVLB   D'2'        ;BANK2
                        CLRF    LATA                    ;ALLES KEIN DATA-LATCH
                        CLRF    LATB
                        
;                        MOVLW   D'2'             ;PIN-ZUORDNUNG FUER SPI UND I2C VERAENDERN  /// HIER NICHT GEMACHT
;                        MOVWF   APFCON0
;                        MOVWF   APFCON1
                        
                        MOVLB   D'1'        ;BANK1
                        MOVLW   B'00111100'             ;INIT INPUT/OUTPUT AM PORTA --> BEI 0 AUSGAENGE -->RA0+RA1 AUSGANG RA6+RA7 LEDS
                        MOVWF   TRISA
                        MOVLW   B'00001111'             ;INIT INPUT/OUTPUT AM PORTB --> BEI 0 AUSGAENGE RB4-7 / BEI 1 EINGAENGE RB0-3 -->TASTATUR
                        MOVWF   TRISB
                        
;FR DEN INTERNEN OSZILLATOR 8MHZ /// HOLE ABER EINSTELLUNGEN AUS CONFIG INTERN "OBEN" UND PLL*4 /// DANN 32MHZ
                        MOVLW   B'11110000'             ;JETZT 8MHZ INTERN OHNE PLL*4 /// OBEN IN CONFIG MIT PLL               
                        MOVWF   OSCCON
                                                
MAIN01                  BTFSS   OSCSTAT, PLLR
                        GOTO    MAIN01                  ;WAIT IF PLL IS READY 
                                                        ;CLOCK IS NOW 32MHZ
MAIN02                  BTFSS   OSCSTAT, HFIOFR
                        GOTO    MAIN02
   
;INIT TIMER0 TON-RA0 MIT INTERRUPT
                        MOVLW   B'10000011'             ;BIT0-2 PRESCALER1:16, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG
                        
                        MOVLB   D'0'        ;BANK0
;INIT TIMER1 TON-DAUER BEI TONFOLGE
                        MOVLW   B'00110000'             ;PRESCALER AUF 1:8 EINGESTELLT + NOCH NICHT GESTARTET
                        MOVWF   T1CON 
                        
                        MOVLB   D'3'        ;BANK3
                        CLRF    ANSELA                  ;ALLES I/O PINS AM PORTS KEIN ANALOG
                        CLRF    ANSELB
                        
                        MOVLB   D'4'        ;BANK4   
                        CLRF    WPUA                    ;ALLES KEIN PULL-UP
                        CLRF    WPUB                  
                        
;---------------------------------------------------------------------------------
                        MOVLB   D'0'         ;BANK0
;ZEITSCHLEIFE 50MSEC                
                        MOVLW   D'200'
                        CALL    ZS250MYSEC
                        
                        BCF     PORTA, LEUCHT
                        BCF     PORTA, ABSPEICHERN
;---------------------------------------------------------------------------------                        
       
;TON-GRUNDZUSTAND
                        CALL    GRUNDZUST 
                        BCF     MERK1, BIT0     ;RA0-BEGINNT MIT LOW-HALBWELLE
                        BCF     MERK1, BIT1     ;RA1-BEGINNT MIT LOW-HALBWELLE                       
                        BCF     SPEICHERN, BIT0 ;NICHT SPEICHERN
                        
;INTERRUPT ZULASSEN ;SPTER            
                        ;BSF     INTCON, GIE     ;ALLGEMEINES INTERRUPT ENABLE !!!!SPAETER BEI TON EIN
                        ;BSF     INTCON, PEIE    ;!!!!SPAETER
                        ;BSF     INTCON, TMR0IE    ;OVERFLOW INTERRUPT BEI TIMER0 ZULASSEN/ENABLE SPTER
                        
;---------------------------------------------------------------------------------                         
                   
                        BSF     AUS, BIT0     ;BEI HIGH BIT0 TONTASTE LOSGELASSEN DANN AUS !!!!JETZT JA
                        BCF     EINMAL, BIT0  ;NUR EINMAL TON_SUCH !!!!JETZT NICHT
             
;ENABLE AN TASTATUR  
EN                     
                        BTFSC   EINMAL, BIT0
                        CALL    TON_SUCH      ;WELCHE TASTE VON DER TASTATUR GEDRUECKT
                        
                        BTFSS   AUS, BIT0     ;BEI HIGH TON-ABSCHALTUNG INTERRUPT AUS  // ABSCHALTUNG "CALL    ZS_TON"    BEI RA1
                        GOTO    TON02
                        
;HIER TASTATUR-TASTE LOSGELASSEN
;DTMF-TON BEENDEN
;INTERRUPT SPERREN                      
LL1     BCF     INTCON, GIE     
        BTFSC   INTCON, GIE
        GOTO    LL1
        
LL2     BCF     INTCON, PEIE 
        BTFSC   INTCON, PEIE
        GOTO    LL2
        
LL3     BCF     INTCON, TMR0IE    ;OVERFLOW INTERRUPT BEI TIMER0 NO ENABLE
        BTFSC   INTCON, TMR0IE
        GOTO    LL3

        BCF     PORTA, LEUCHT     ;LED BEIM TASTATUR BETTIGEN AUS
;        BANK1
;LL4     BCF     PIE1, TMR1IE    ;OVERFLOW INTERRUPT BEI TIMER1 NO ENABLE
;        BTFSC   PIE1, TMR1IE
;        GOTO    LL4
;        BANK0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;WARTEN OB EINE TONFOLGE-TASTE GEDRUECKT IST
SUCH_TAST00
                        CALL    GRUNDZUST 
                        BCF     MERK1, BIT0     ;RA0-BEGINNT MIT LOW-HALBWELLE
                        BCF     MERK1, BIT1     ;RA1-BEGINNT MIT LOW-HALBWELLE                       
                                
        MOVLW   D'80'       ;80*0,250MSEC=20MSEC
        MOVWF   HELP1
SUCH_TAST21                   
        MOVF    PORTA, W    
        ANDLW   B'00111100'     
        SUBLW   B'00111100'        
        BTFSC   STATUS, Z   
        GOTO    SUCH_TON00   ;SUCH_TAST00 NEIN!!!

        MOVLW   D'1'
        CALL    ZS250MYSEC
        DECFSZ  HELP1, F
        GOTO    SUCH_TAST21
        
                              
        MOVF    PORTA, W    
        ANDLW   B'00111100'
        MOVWF   TAST_MERKER
        CALL    SUCH_TASTER               ;ADRESSEN ZUM ABSPEICHERN UND ABSPIELEN SUCHEN
        
              MOVLW   D'60'               ;60*0,05SEC=3SEC LANG DAUERDRUECKEN, DANN WIRD GESPEICHERT
              MOVWF   HELP
P1            BCF     T1CON, TMR1ON       ;STOP TIMER1        
              BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  
              MOVLW   0XAF                ;ZEIT JEDES MAL NEU EINSTELLEN LOW-BYTE
              MOVWF   TMR1L               ;
              MOVLW   0X3C                ;ZEIT JEDES MAL NEU EINSTELLEN HIGH-BYTE
              MOVWF   TMR1H               ;
              BSF     T1CON, TMR1ON       ;START TIMER1      
        
;ZEITBERECHNUNG FR 100MSEC
;PRESCALER 8X  *  SYSTEM 4X  * TAKTZEIT ====> 8*4*0.03125SEC=1,0SEC 
;50MS : 1,0SEC= 50.000                                      
;DA ES 2 BYTE SIND FR DIE ZEIT IST DIE GRSSTE ZAHL 0XFFFF = D'65535'
;ALSO
;0XFFFF (D'65535') - 0XC350 (D'50000') = 0X3CAF 
;TMR1L = 0XAF  UND  TMR1H = 0X3C  DIES OBEN EINTRAGEN

P2            BTFSC   PIR1, TMR1IF        ;SPRUNG BEI OVERFLOW = 1 ,WENN ZEIT ERREICHT 100MSEC * 50 = 5SEC
              GOTO    P3
              
              MOVF    PORTA, W    
              ANDLW   B'00111100'
              SUBWF   TAST_MERKER, W
              BTFSC   STATUS, Z
              GOTO    P2
              
              BCF     PORTA, ABSPEICHERN ;LED LEUCHTET NICHT, WENN MAN DENM SPEICHER-MODUS VERLAESST
              CALL    ABSPIELEN  
              BCF     SPEICHERN, BIT0 ;SPEICHERN SPERREN IN "CALL TON_SUCH"
         GOTO    EN

P3            DECFSZ  HELP, F             ;SPRUNG BEI 0 -->3SEC SIND VORBEI BEI DAUERDRUCK
              GOTO    P1
              
              BCF     MERK1, BIT0   ;RA0-BEGINNT MIT LOW-HALBWELLE ALS TON 
              BCF     MERK1, BIT1   ;RA1-BEGINNT MIT LOW-HALBWELLE
              BSF     EINMAL, BIT0  ;NUR EINMAL "TON_SUCH"
                
              BSF     SPEICHERN, BIT0 ;SPEICHERN ZULASSEN IN "CALL TON_SUCH"
              BSF     PORTA, ABSPEICHERN ;LED LEUCHTET, WENN MAN IM SPEICHER-MODUS IST
              CALL    WARN_TON_TAST             
        GOTO    EN          ;"CALL TON_SUCH" WIRD EIN MAL ABGEARBEITET
                            ;MAN KANN MIT DER TASTUR DIE TONFOLGE-TOENE EINGEBEN ZUM ABSPEICHERN
                            
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;                        
;WARTEN OB NOCH EINE TASTATUR-TASTE GEDRUECKT IST
SUCH_TON00 
        MOVLW   B'00001111'
        MOVWF   PORTB
        
SUCH_TON11
        MOVLW   D'80'       ;80*0,250MSEC=20MSEC
        MOVWF   HELP1
SUCH_TON21        
        MOVF    PORTB, W    
        ANDLW   0X0F
        SUBLW   0X0F        
        BTFSC   STATUS, Z  
        GOTO    SUCH_TAST00 ;HAENGT HIER BIS TASTATUR ODER TONFOLGE-TASTER GEDRUECKT!!!!!!!!!!

        MOVLW   D'1'        ;SIEHE OBEN 20MSEC
        CALL    ZS250MYSEC  ;FUER ENTPRELLEN TASTATUR // BEI TASTATUR GEDRUECKT
        DECFSZ  HELP1, F
        GOTO    SUCH_TON21
                
                        CALL    GRUNDZUST
                        BCF     MERK1, BIT0   ;RA0-BEGINNT MIT LOW-HALBWELLE ALS TON 
                        BCF     MERK1, BIT1   ;RA1-BEGINNT MIT LOW-HALBWELLE
                        BSF     EINMAL, BIT0  ;NUR EINMAL "TON_SUCH"
                        
        GOTO    EN          ;"CALL TON_SUCH" WIRD EIN MAL ABGEARBEITET
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
                
TON02
;TON AN RA1
        BTFSS   MERK1, BIT1
        GOTO    TON01
         
        BSF     PORTA, BIT1
        BCF     MERK1, BIT1
        
        CALL    ZS_TON       ;MIT ABSCHALTUNG TASTATUR LOSGELASSEN
        GOTO    EN
        
TON01
        BCF     PORTA, BIT1
        BSF     MERK1, BIT1

        CALL    ZS_TON
        GOTO    EN

 
;*****************************************************************************
;*                            TASTER-ADRESSEN  SUCHEN                        *
;*****************************************************************************
SUCH_TASTER
              BTFSC     PORTA, TASTE1     ;TASTE1 TONFOLGE ABSPIELEN/SPEICHERN
              GOTO      SUCH_TAST01
              MOVLW     0X00
              MOVWF     ADRR
              MOVLW     0X1D              ;30TOENE MAXIMAL 0X1D
              MOVWF     ADRR_END
              RETURN
              
SUCH_TAST01   BTFSC     PORTA, TASTE2     ;TASTE2 TONFOLGE ABSPIELEN/SPEICHERN
              GOTO      SUCH_TAST02              
              MOVLW     0X20
              MOVWF     ADRR
              MOVLW     0X3D              ;30TOENE MAXIMAL 0X3D        
              MOVWF     ADRR_END
              RETURN
              
SUCH_TAST02   BTFSC     PORTA, TASTE3     ;TASTE2 TONFOLGE ABSPIELEN/SPEICHERN
              GOTO      SUCH_TAST03              
              MOVLW     0X40
              MOVWF     ADRR
              MOVLW     0X5D              ;30TOENE MAXIMAL 0X5D        
              MOVWF     ADRR_END
              RETURN
        
SUCH_TAST03   BTFSC     PORTA, TASTE4     ;TASTE2 TONFOLGE ABSPIELEN/SPEICHERN
              RETURN              
              MOVLW     0X60
              MOVWF     ADRR
              MOVLW     0X7D              ;30TOENE MAXIMAL 0X7D        
              MOVWF     ADRR_END
              RETURN
              
;*****************************************************************************
;*                            TONWERTE SUCHEN                                *
;*****************************************************************************
TON_SUCH
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;WELCHE TASTE WURDE GEDRUECKT
        MOVLW   B'11101111' ;BIT4 ABFRAGEN RB4
        MOVWF   PORTB
        CALL    ZS1MYSEC 
        
        BTFSC   PORTB, BIT0 ;1
        GOTO    WEITER01
        MOVLW   D'1'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER01        
        BTFSC   PORTB, BIT1 ;4
        GOTO    WEITER02
        MOVLW   D'4'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER02        
        BTFSC   PORTB, BIT2 ;7
        GOTO    WEITER03
        MOVLW   D'7'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER03        
        BTFSC   PORTB, BIT3 ;*
        GOTO    WEITER_A
        MOVLW   D'11'
        MOVWF   ZAE1
        GOTO    WEITERXX
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
WEITER_A        
        MOVLW   B'11011111' ;BIT5 ABFRAGEN RB5
        MOVWF   PORTB
        CALL    ZS1MYSEC 
        
        BTFSC   PORTB, BIT0 ;2
        GOTO    WEITER05
        MOVLW   D'2'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER05        
        BTFSC   PORTB, BIT1 ;5
        GOTO    WEITER06
        MOVLW   D'5'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER06        
        BTFSC   PORTB, BIT2 ;8
        GOTO    WEITER07
        MOVLW   D'8'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER07        
        BTFSC   PORTB, BIT3 ;0
        GOTO    WEITER_B
        MOVLW   D'10'
        MOVWF   ZAE1
        GOTO    WEITERXX
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
WEITER_B        
        MOVLW   B'10111111' ;BIT6 ABFRAGEN RB6
        MOVWF   PORTB
        CALL    ZS1MYSEC
        
        BTFSC   PORTB, BIT0 ;3
        GOTO    WEITER09
        MOVLW   D'3'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER09        
        BTFSC   PORTB, BIT1 ;6
        GOTO    WEITER10
        MOVLW   D'6'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER10        
        BTFSC   PORTB, BIT2 ;9
        GOTO    WEITER11
        MOVLW   D'9'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER11        
        BTFSC   PORTB, BIT3 ;#
        GOTO    WEITER_C
        MOVLW   D'12'
        MOVWF   ZAE1
        GOTO    WEITERXX
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
WEITER_C        
        MOVLW   B'01111111' ;BIT7 ABFRAGEN RB7
        MOVWF   PORTB
        CALL    ZS1MYSEC
        
        BTFSC   PORTB, BIT0 ;A
        GOTO    WEITER13
        MOVLW   D'13'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER13        
        BTFSC   PORTB, BIT1 ;B
        GOTO    WEITER14
        MOVLW   D'14'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER14        
        BTFSC   PORTB, BIT2 ;C
        GOTO    WEITER15
        MOVLW   D'15'
        MOVWF   ZAE1
        GOTO    WEITERXX

WEITER15        
        BTFSC   PORTB, BIT3 ;D
        GOTO    TON_SUCH
        MOVLW   D'0'
        MOVWF   ZAE1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;TIMER0 START UND INTERRUPT
WEITERXX
        CALL    WERT_RA0     ;AUSLESEN ZEIT-WERTE FUER TON-SCHLEIFE-ZAE UND TIMER0-INTERRUPT
        MOVWF   TON_RA0
        CALL    WERT_RA1
        MOVWF   TON_RA1
        BSF     PORTA, LEUCHT ;LED BEIM TASTATUR BETTIGEN EIN        

;SPEICHERN SPERREN / ZULASSEN
        BTFSS   SPEICHERN, BIT0
        GOTO    WEITERYY
;TOENE SPEICHERN IN EEPROM ==> ENDE-ERKENNUNG
        MOVF    ADRR, W
        SUBWF   ADRR_END, W           ;MAXIMALE ANZAHL VON ABSPEICHERBAREN TOENEN 
        BTFSS   STATUS, C             ;GROESSER C=LOW
        GOTO    WEITERYY1
        
;SPEICHERN      
        MOVF    ZAE1, W
        CALL    E_WRITE
        INCF    ADRR, F
        MOVLW   0XFF
        CALL    E_WRITE

WEITERYY        
        BCF     AUS, BIT0     ;BEI HIGH BIT0 TONTASTE NICHT LOSGELASSEN / NICHT AUS / AUSSCHALTUNG IN "CALL ZS_TON" ODER SO HNLICH      
        BCF     EINMAL, BIT0  ;CALL TON_SUCH NICHT AKTIV
        
;START TIMER0 MIT INTERRUPT TON 
        MOVF    TON_RA0, W 
        MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, TMR0IF    ;OVERFLOW 
        BSF     INTCON, GIE    ;SCHON OBEN BEI MAIN !!!!NEIN
        BSF     INTCON, PEIE   ;SCHON OBEN BEI MAIN !!!!NEIN
        BSF     INTCON, TMR0IE    ;OVERFLOW INTERRUPT BEI TIMER0 ZULASSEN/ENABLE
        RETURN
        
WEITERYY1
        BCF     SPEICHERN, BIT0
        BCF     PORTA, ABSPEICHERN ;LED LEUCHTET NICHT, WENN MAN IM SPEICHER-UEBERLAUF IST ES WIRD NICHTS MEHR GESPEICHERT
        BCF     PORTA, LEUCHT      ;MUSS SEIN
        CALL    WARN_TON_UEBERL
        GOTO    WEITERYY
        
;*****************************************************************************
;*                            INTERRUPT-PROGRAMM TON AN RA0                  *
;*****************************************************************************
INTERRUPT
        PPUSH
        BTFSC   INTCON, TMR0IF 
        GOTO    INT00

;TONLNGE DAUER * 0,5SEC (MAL 2 WEGEN 0,1SEC) ==>        
        BCF     T1CON, TMR1ON       ;STOP TIMER1
        BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  
        MOVLW   0XAF                
        MOVWF   TMR1L               
        MOVLW   0X3C               
        MOVWF   TMR1H
        
        DECFSZ  DAUER2, F
        GOTO    INT10
        MOVLW   D'2'
        MOVWF   DAUER2
        DECFSZ  DAUER, F
        GOTO    INT10
        
        BCF     T1CON, TMR1ON   ;STOP TIMER1
        BSF     SYSS, BIT0
        PPOP
        RETFIE
        
INT10
        BSF     T1CON, TMR1ON   ;START TIMER1
        BCF     SYSS, BIT0
        PPOP
        RETFIE
        
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;        
INT00        
        BTFSS   MERK1, BIT0
        GOTO    INT02
        
        BSF     PORTA, BIT0
        BCF     MERK1, BIT0
        GOTO    INT01
        
INT02
        BCF     PORTA, BIT0
        BSF     MERK1, BIT0
INT01
;TIMER0 START                        
        MOVF    TON_RA0, W 
        MOVWF   TMR0              ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, TMR0IF    ;OVERFLOW
 
        PPOP
        RETFIE
        
;*****************************************************************************
;*                            ZEITSCHLEIFE TON BEI TASTATUR GEDRUECKT        *
;*****************************************************************************
ZS_TON
 
        MOVF    TON_RA1, W   
        MOVWF   ZAE
        
ZS_TON1
        MOVF    PORTB, W    ;NOP  ;AUS-SCHALTEN TON // TASTE NICHT MEHR GEDRUECKT
        ANDLW   0X0F        ;NOP
        SUBLW   0X0F        ;NOP
        BTFSC   STATUS, Z   ;NOP
        BSF     AUS, BIT0   ;NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                 
        NOP
        NOP
        NOP
        NOP
        NOP
             
        NOP
        NOP
        NOP
        NOP
        NOP
                    
        NOP
        NOP
        NOP
        NOP
        NOP     ;25STCK. NOPS
        
        DECFSZ  ZAE, F
        GOTO    ZS_TON1

        RETURN
        
                 
;*****************************************************************************
;*                            ZEITSCHLEIFE TON BEI TONFOLGE                  *
;*****************************************************************************
ZS_TON_ABSP
 
        MOVF    TON_RA1, W   
        MOVWF   ZAE
        
ZS_TON11
        NOP
        NOP
        NOP
        NOP
        NOP
        
        NOP
        NOP
        NOP
        NOP
        NOP
          
        NOP
        NOP
        NOP
        NOP
        NOP
                 
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;25STCK. NOPS
        
        DECFSZ  ZAE, F
        GOTO    ZS_TON11

        RETURN
               
;*****************************************************************************
;*                            GESPEICHERTE TONFOLGE ABSPIELEN                *
;*****************************************************************************
ABSPIELEN
        ;CLRF    ADRR     ;AB EEPROM-ADRESSE 0X00
        
AB01
        CALL    E_READ
        MOVWF   ZAE1
        
        SUBLW   0XFF            ;ENDE ERKENNUNG DER TONFOLGE        
        BTFSS   STATUS, Z
        GOTO    AABB01
        BCF     PORTA, LEUCHT     ;LED BEIM ABSPIELEN AUS ENDE
        RETURN   
        
AABB01  
        CALL    WERT_RA0
        MOVWF   TON_RA0
        CALL    WERT_RA1
        MOVWF   TON_RA1

;TON-GRUNDZUSTAND
                        CALL    GRUNDZUST 
                        BCF     MERK1, BIT0     ;RA0-BEGINNT MIT LOW-HALBWELLE
                        BCF     MERK1, BIT1     ;RA1-BEGINNT MIT LOW-HALBWELLE        
                        
;TIMER1 TONLNGE DAUER * 0,05SEC (DAUER2=2 WEGEN 0,1SEC) =>
        BSF     PORTA, LEUCHT     ;LED BEIM ABSPIELEN EIN
        
        MOVLW   TONLAENGE
        MOVWF   DAUER
        MOVLW   D'2'
        MOVWF   DAUER2
        
        BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  
        MOVLW   0XAF                
        MOVWF   TMR1L               
        MOVLW   0X3C                
        MOVWF   TMR1H
        
        MOVLB   D'1'            ;BANK1
        BSF     PIE1, TMR1IE    ;OVERFLOW INTERRUPT BEI TIMER1 ZULASSEN/ENABLE
        MOVLB   D'0'            ;BANK0
        BSF     T1CON, TMR1ON            
        
        
;TIMER0 TON RA0 IM INTERRUPT        
        MOVF    TON_RA0, W 
        MOVWF   TMR0            
        BCF     INTCON, TMR0IF ;OVERFLOW 0 MACHEN        

        BSF     INTCON, GIE    ;SCHON OBEN BEI MAIN
        BSF     INTCON, PEIE   ;SCHON OBEN BEI MAIN
        BSF     INTCON, TMR0IE    ;OVERFLOW INTERRUPT BEI TIMER0 ZULASSEN/ENABLE
        
        BCF     SYSS, BIT0
        
           
TON022
;TON AN RA1
        BTFSS   MERK1, BIT1
        GOTO    TON011
         
        BSF     PORTA, BIT1
        BCF     MERK1, BIT1
        
        CALL    ZS_TON_ABSP
        BTFSS   SYSS, BIT0
        GOTO    TON022
        GOTO    TT1
TON011
        BCF     PORTA, BIT1
        BSF     MERK1, BIT1

        CALL    ZS_TON_ABSP
        BTFSS   SYSS, BIT0
        GOTO    TON022
        GOTO    TT1


TT1        
        BCF     INTCON, TMR0IE    ;OVERFLOW INTERRUPT BEI TIMER0 NO ENABLE
        BTFSC   INTCON, TMR0IE
        GOTO    TT1
        
        MOVLB   D'1'            ;BANK1
TT2     BCF     PIE1, TMR1IE    ;OVERFLOW INTERRUPT BEI TIMER1 NO ENABLE
        BTFSC   PIE1, TMR1IE
        GOTO    TT2
        MOVLB   D'0'         ;BANK0
        
        
        INCF    ADRR, F
        
;TONPAUSE
              BCF       PORTA, LEUCHT     ;LED BEIM ABSPIELEN AUS
              
              MOVLW     TONPAUSE
              MOVWF     DAUER
              MOVLW     D'2'
              MOVWF     DAUER2

P222          BCF     T1CON, TMR1ON       ;STOP TIMER1        
              BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  
              MOVLW   0XAF                ;ZEIT JEDES MAL NEU EINSTELLEN LOW-BYTE
              MOVWF   TMR1L               ;
              MOVLW   0X3C                ;ZEIT JEDES MAL NEU EINSTELLEN HIGH-BYTE
              MOVWF   TMR1H               ;
              BSF     T1CON, TMR1ON       ;START TIMER1      
        
P444          BTFSS   PIR1, TMR1IF
              GOTO    P444
        
        DECFSZ  DAUER2, F
        GOTO    P333
        MOVLW   D'2'
        MOVWF   DAUER2      
        DECFSZ  DAUER, F
        GOTO    P333
        BCF     T1CON, TMR1ON   ;STOP TIMER1
        GOTO    AB01
   
P333    BSF     T1CON, TMR1ON   ;START TIMER1
        GOTO    P222


;*****************************************************************************
;*                            GRUNDZUSTAND FUER TON-MOSFETS                  *
;*****************************************************************************
GRUNDZUST
                        BCF     PORTA, BIT0
                        CALL    ZS1MYSEC 
                        BCF     PORTA, BIT1
                        RETURN
                        
;*****************************************************************************
;*                            ZEITSCHEIFE 1SEC                              *
;*****************************************************************************
ZS1MYSEC                        
;TAKTZEIT ====> 8*NOP(JE T=4)*0.03125SEC=1,0SEC
                        NOP
                        NOP
                        NOP
                        NOP
                        
                        NOP
                        NOP
                        NOP
                        NOP
                        RETURN                  
                        
;TAKTZEIT ====> 8*NOP(JE T=4)*0.03125SEC=1,0SEC
                        
                        
;*****************************************************************************
;*                            ZEITSCHEIFE 0,250MSEC * X                      *
;*****************************************************************************
ZS250MYSEC 
        MOVWF   HELP

ZS1     MOVLW   D'131'
        MOVWF   TMR0            ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
        BCF     INTCON, TMR0IF  ;OVERFLOW
        
ZS      BTFSS   INTCON, TMR0IF
        GOTO    ZS

        DECFSZ  HELP, F
        GOTO    ZS1
        
        RETURN

;ZEITBERECHNUNG FUER 250SEC
;PRESCALER 16X  +  SYSTEM 4X  ====> 16*4*0.03125SEC=2SEC
;250SEC:2SEC=125   
;TMR0 ALSO D'256'-D'125'=D'131' ENTSPRICHT CA. 250SEC
;131 DEZIMAL OBEN EINTRAGEN
                        
;*****************************************************************************
;*                            EEPROM-SCHREIBEN                               *
;*****************************************************************************
;DIE EEPROMADRESSE MUSS IN ADRR STEHEN
;DAS ZU SPEICHERNDE BYTE IN W
E_WRITE  
                MOVLB   D'3'        ;BANK3
                MOVWF   EEDATL
                MOVLB   D'0'        ;BANK0
                MOVF    ADRR, W
                MOVLB   D'3'        ;BANK3
                MOVWF   EEADRL
            
                BCF     EECON1, CFGS
                BCF     EECON1, EEPGD
                BSF     EECON1, WREN
                MOVLW   0X55
                MOVWF   EECON2
                MOVLW   0XAA
                MOVWF   EECON2
                BSF     EECON1, WR
                BCF     EECON1, WREN
                
E_01            BTFSC   EECON1, WR
                GOTO    E_01
                
                MOVLB   D'0'        ;BANK0
                
                RETURN
                
;*****************************************************************************
;*                            EEPROM-LESEN                                   *
;*****************************************************************************
;ADR MUSS MIT DER EEPROM-ADRESSE GELADEN SEIN, WELCHE GELESEN WERDEN SOLL
;DAS ERGEBNIS DES WERTES VOM EEPROM-INHALT STEHT AM ENDE IN W

E_READ          MOVF    ADRR, W
                MOVLB   D'3'                ;BANK3
                MOVWF   EEADRL
                BCF     EECON1, CFGS
                BCF     EECON1, EEPGD
                BSF     EECON1, RD
                MOVF    EEDATL, W
                MOVLB   D'0'
                
                RETURN  
                
;*****************************************************************************
;*                            WARNTON                                        *
;*****************************************************************************       
WARN_TON_TAST
        MOVF    PORTA, W    
        ANDLW   B'00111100'
        MOVWF   TAST_MERKER
        
WARN_TON_TAST1  
        MOVLW   D'250'
        MOVWF   ZAE
                        BSF     PORTA, BIT0
                        CALL    ZS1MYSEC
                        BSF     PORTA, BIT1
ZS_TON_EIN
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        DECFSZ  ZAE, F
        GOTO    ZS_TON_EIN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
        
        MOVLW   D'250'
        MOVWF   ZAE
                        BCF     PORTA, BIT0
                        CALL    ZS1MYSEC
                        BCF     PORTA, BIT1
ZS_TON_AUS
        MOVF    PORTA, W    
        ANDLW   B'00111100'
        SUBWF   TAST_MERKER, W
        BTFSS   STATUS, Z
        GOTO    TON_SCHLUSS     
 
        ;NOP
        ;NOP
        ;NOP
        ;NOP
        ;NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        DECFSZ  ZAE, F
        GOTO    ZS_TON_AUS
        GOTO    WARN_TON_TAST1
        
TON_SCHLUSS
;ENTPRELLEN FESTE ZEIT
        MOVLW   D'80'       ;20MSEC
        CALL    ZS250MYSEC
        RETURN
        

;*****************************************************************************
;*                            WARNTON                                        *
;*****************************************************************************
WARN_TON_UEBERL
              MOVLW   D'100'     ;0,05SEC*100=5SEC TON-PIEPS
              MOVWF   HELP2
              
WARN_TON_UEBERL2
              BCF     T1CON, TMR1ON       ;STOP TIMER1        
              BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN  
              MOVLW   0XAF                ;ZEIT JEDES MAL NEU EINSTELLEN LOW-BYTE
              MOVWF   TMR1L               ;
              MOVLW   0X3C                ;ZEIT JEDES MAL NEU EINSTELLEN HIGH-BYTE
              MOVWF   TMR1H               ;
              BSF     T1CON, TMR1ON       ;START TIMER1 
              
WARN_TON_UEBERL1
        MOVLW   D'250'
        MOVWF   ZAE
                        BSF     PORTA, BIT0
                        CALL    ZS1MYSEC
                        BSF     PORTA, BIT1
ZZS_TON_EIN             
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        DECFSZ  ZAE, F
        GOTO    ZZS_TON_EIN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
        
        MOVLW   D'250'
        MOVWF   ZAE
                        BCF     PORTA, BIT0
                        CALL    ZS1MYSEC
                        BCF     PORTA, BIT1
ZZS_TON_AUS1        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        NOP
        NOP
        NOP
        NOP
        NOP
         
        NOP
        NOP
        NOP
        NOP
        NOP
                
        NOP
        NOP
        NOP
        NOP
        NOP     ;15STCK. NOPS
        
        DECFSZ  ZAE, F
        GOTO    ZZS_TON_AUS1
        
        BTFSS   PIR1, TMR1IF    
        GOTO    WARN_TON_UEBERL1
        DECFSZ  HELP2, F
        GOTO    WARN_TON_UEBERL2
        
TTON_SCHLUSS
;ENTPRELLEN FESTE ZEIT
        MOVLW   D'80'       ;20MSEC
        CALL    ZS250MYSEC
        RETURN
        
                                
                
                
                
                ORG 0X0700
;*****************************************************************************
;*                       WERT_RA0 AUSLESEN MIT TIMER0 ALS INTERRUPT          *
;*****************************************************************************
WERT_RA0
    MOVLW   H'07'       ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

;HIER PRESCALER 1:16    
    RETLW   D'104'    ;ADRESSE 0X00 DER TON "D" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'51'     ;ADRESSE 0X01 DER TON "1" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0    
    RETLW   D'71'     ;ADRESSE 0X02 DER TON "2" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0        
    RETLW   D'88'     ;ADRESSE 0X03 DER TON "3" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'51'     ;ADRESSE 0X04 DER TON "4" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'71'     ;ADRESSE 0X05 DER TON "5" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'88'     ;ADRESSE 0X06 DER TON "6" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'51'     ;ADRESSE 0X07 DER TON "7" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'71'     ;ADRESSE 0X08 DER TON "8" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'88'     ;ADRESSE 0X09 DER TON "9" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'71'     ;ADRESSE 0X0A DER TON "0" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'51'     ;ADRESSE 0X0B DER TON "*" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'88'     ;ADRESSE 0X0C DER TON "#" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'104'    ;ADRESSE 0X0D DER TON "A" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'104'    ;ADRESSE 0X0E DER TON "B" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    RETLW   D'104'    ;ADRESSE 0X0F DER TON "C" FUER RA0-AUSGANG MIT INTERRUPT-TIMER0
    
 
;*****************************************************************************
;*                       WERT_RA1 AUSLESEN MIT NOPS-ZEITSCHLEIFE             *
;*****************************************************************************
WERT_RA1
    MOVLW   H'07'       ;ADRESSE SPEICHERN NEUES PCLATH
    MOVWF   PCLATH

    MOVF    ZAE1, W     ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    RETLW   D'149'   ;ADRESSE 0X00 DER TON "D" FUER RA1-AUSGANG 
    RETLW   D'202'   ;ADRESSE 0X01 DER TON "1" FUER RA1-AUSGANG     
    RETLW   D'202'   ;ADRESSE 0X02 DER TON "2" FUER RA1-AUSGANG         
    RETLW   D'202'   ;ADRESSE 0X03 DER TON "3" FUER RA1-AUSGANG 
    RETLW   D'182'   ;ADRESSE 0X04 DER TON "4" FUER RA1-AUSGANG 
    RETLW   D'182'   ;ADRESSE 0X05 DER TON "5" FUER RA1-AUSGANG 
    RETLW   D'182'   ;ADRESSE 0X06 DER TON "6" FUER RA1-AUSGANG 
    RETLW   D'165'   ;ADRESSE 0X07 DER TON "7" FUER RA1-AUSGANG 
    RETLW   D'165'   ;ADRESSE 0X08 DER TON "8" FUER RA1-AUSGANG 
    RETLW   D'165'   ;ADRESSE 0X09 DER TON "9" FUER RA1-AUSGANG 
    RETLW   D'150' ;D'149'   ;ADRESSE 0X0A DER TON "0" FUER RA1-AUSGANG 
    RETLW   D'150' ;D'149'   ;ADRESSE 0X0B DER TON "*" FUER RA1-AUSGANG 
    RETLW   D'149'   ;ADRESSE 0X0C DER TON "#" FUER RA1-AUSGANG 
    RETLW   D'202'   ;ADRESSE 0X0D DER TON "A" FUER RA1-AUSGANG 
    RETLW   D'182'   ;ADRESSE 0X0E DER TON "B" FUER RA1-AUSGANG 
    RETLW   D'165'   ;ADRESSE 0X0F DER TON "C" FUER RA1-AUSGANG        
                                 
        
        
        
;---------------------------------------------------------------------------------                        
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------                        
;---------------------------------------------------------------------------------        
;FUER RA1 MIT NOPS ALS ZEITSCHLEIFE
    
;BEI DER "1" --> SOLL 697HZ ---TIEFSTE FREQUENZ HOECHSTER TABELLENWERT
    
;T=1:FREQUENZ /// T=1:697HZ=1.434MSEC /// DA NUR EINE HALBWELLE :2=717SEC
;NOP ZEITSCHLEIFEN BERECHNUNG FUER 717SEC      
 
;QUARZ-TAKTZEIT FUER 1 MAL NOP BEFEHL ===> 0.03125SEC * 4 =0,125SEC
;FESTE ANZAHL NOPS MIT 25STCK. -->25*0.125SEC=3,125SEC
    
;717SEC : 3,125SEC = D'229' DURCHLAEUFE   MIT JEWEILS 25MAL NOP
        
;KORREKTUR IST-WERT
;BEI D'229' 614HZ    
;BEI D'209' 672HZ /PROPORTION 1=5,8HZ
;BEI D'205' 685HZ
;BEI D'202' 695,7HZ   
;-----------------------------------------------------------------        
;BEI DER "4" --> SOLL 770HZ
    
;KORREKTUR    
;BEI D'190' 739HZ
;BEI D'183' 767HZ
;BEI D'182' 772HZ       
;-----------------------------------------------------------------        
;BEI DER "7" --> SOLL 852HZ
    
;KORREKTUR    
;BEI D'167' 841HZ
;BEI D'165' 851HZ   
;-----------------------------------------------------------------        
;BEI DER "*" --> SOLL 941HZ
    
;KORREKTUR    
;BEI D'149' 942HZ
    
;---------------------------------------------------------------------------------                        
;---------------------------------------------------------------------------------
;---------------------------------------------------------------------------------                        
;---------------------------------------------------------------------------------
;FUER RA0 INTERRUPT TIMER0
;BERECHNUNG TIMER0 FUER 1209HZ TIEFSTE FREQUENZ
;T=1:FREQUENZ /// T=1:1209HZ=827SEC /// DA NUR EINE HALBWELLE :2=413,5SEC
                        
;BEI "1" 
;ZEITBERECHNUNG FUER 413,5SEC
;PRESCALER 16X  *  SYSTEM 4X  * TAKTZEIT ====> 16*4*0.03125SEC=2.0SEC 
;413,5SEC : 2.0SEC= 206,75  GENOMMEN GANZAHLIG 207 
;TMR0 ALSO D'256'-D'207'=D'49' 
;49 DEZIMAL OBEN EINTRAGEN
;-----------------------------------------------------------------        
;BEI DER "1" --> SOLL 1209HZ
 
;KORREKTUR
;BEI D'49' 1.199HZ
;BEI D'54' 1.227HZ    
;BEI D'51' 1.210HZ 
;-----------------------------------------------------------------        
;BEI DER "2" --> SOLL 1336HZ
 
;KORREKTUR
;BEI D'74' 1.362HZ
;BEI D'69' 1.326HZ
;BEI D'71' 1.340HZ GENOMMEN
;BEI D'70' 1.332HZ    
;-----------------------------------------------------------------        
;BEI DER "3" --> SOLL 1477HZ
 
;KORREKTUR
;BEI D'93' 1.519HZ
;BEI D'88' 1.475HZ 
;-----------------------------------------------------------------        
;BEI DER "A" --> SOLL 1633HZ
 
;KORREKTUR
;BEI D'107' 1.661HZ
;BEI D'103' 1.618HZ
;BEI D'101' 1.598HZ
;BEI D'105' 1.639HZ
;BEI D'104' 1.628HZ GENOMMEN    
;---------------------------------------------------------------------------------                    

                END


    
    
    
    
    
    
    
    
    
    
    
    
    














